#!/bin/sh

LC_NUMERIC=en_US.UTF-8
export LC_NUMERIC

INPUTFILE=sat-aloha.tr

cat $INPUTFILE | #gawk '{print $1}' |
	gawk '
	BEGIN { generated = collisions = serviced = dropped = 0; }
	{
		if ($1 == "r") { serviced++; }
		if ($1 == "c") { collisions++; }
		if ($1 == "d") { dropped++; }
		if ($1 == "+") { generated++; }
	}
	END {
		print "Generated Packets		:",generated;
		print "Serviced Packets		:", serviced;
		print "Collisions			:",collisions;
		print "Dropped				:",dropped;
		print "Mean numb. of Collisions	:",collisions/generated;
		print "% of successful delivery	:",serviced/generated
	}'

cat $INPUTFILE | gawk '
	{
		if ($1 == "+") { print 1000+$12,$2,"0+"; }
		if ($1 == "r") { print 1000+$12,$2,"3r"; }
	}' | sort | gawk '
	BEGIN { delay = pdelay = 0.0; count = count1 = p = 0; }
	{
		count1++;
		if (p == $1) {
			count++;
			delay += $2 - pdelay;
		}
		p = $1;
		pdelay = $2;
	}
	END {
		delay=(1000*delay)/count;
		print "Mean delay (msec)		:", delay
	}'
